<?php
/**
 * @file
 * @package xdbase
 * @version $Id: oninstall.php,v 1.5 2010/06/16 10:27:09 bluemelon Exp $
 */

eval('function xoops_module_install_'.$mydirname.'($module) { return xdbase_oninstall_base($module, "'.$mydirname.'") ; }');

if (!function_exists('xdbase_oninstall_base'))
{

if (!defined('_MD_XDBASE_CONST_MODULEDIRNAME')) define('_MD_XDBASE_CONST_MODULEDIRNAME', $mydirname);

function xdbase_oninstall_base($module, $mydirname)
{
	// transations on module install

	global $ret ; // TODO :-D

	include_once XOOPS_TRUST_PATH.'/modules/'.XDBASE_TRUST_DIRNAME.'/include/function.php';

	// for Cube 2.1
	if ( defined( 'XOOPS_CUBE_LEGACY' ) ) {
		$root =& XCube_Root::getSingleton();
		$root->mDelegateManager->add( 'Legacy.Admin.Event.ModuleInstall.' . ucfirst($mydirname) . '.Success' , 'xdbase_message_append_oninstall' ) ;
		$ret = array() ;
	} else {
		if ( ! is_array( $ret ) ) $ret = array() ;
	}

	$db =& Database::getInstance() ;
	$mid = $module->getVar('mid') ;

	// TABLES (loading mysql.sql)
	$sql_file_path = dirname(__FILE__).'/sql/mysql.sql' ;
	$prefix_mod = $db->prefix() . '_' . $mydirname ;
	if ( file_exists( $sql_file_path ) ) {
		$ret[] = "SQL file found at <b>".htmlspecialchars($sql_file_path)."</b>.<br /> Creating tables...";

		if ( file_exists( XOOPS_ROOT_PATH.'/class/database/oldsqlutility.php' ) ) {
			include_once XOOPS_ROOT_PATH.'/class/database/oldsqlutility.php' ;
			$sqlutil =& new OldSqlUtility ;
		} else {
			include_once XOOPS_ROOT_PATH.'/class/database/sqlutility.php' ;
			$sqlutil =& new SqlUtility ;
		}

		$sql_query = trim( file_get_contents( $sql_file_path ) ) ;
		$sqlutil->splitMySqlFile( $pieces , $sql_query ) ;
		$created_tables = array() ;
		if ( is_array( $pieces ) ) foreach ( $pieces as $piece ) {
			$prefixed_query = $sqlutil->prefixQuery( $piece , $prefix_mod ) ;
			if ( ! $prefixed_query ) {
				$ret[] = "Invalid SQL <b>".htmlspecialchars($piece)."</b><br />";
				return false ;
			}
			if ( ! $db->query( $prefixed_query[0] ) ) {
				$ret[] = '<b>'.htmlspecialchars( $db->error() ).'</b><br />' ;
				return false ;
			} else {
				if ( ! in_array( $prefixed_query[4] , $created_tables ) ) {
					$ret[] = 'Table <b>'.htmlspecialchars($prefix_mod.'_'.$prefixed_query[4]).'</b> created.<br />';
					$created_tables[] = $prefixed_query[4];
				} else {
					$ret[] = 'Data inserted to table <b>'.htmlspecialchars($prefix_mod.'_'.$prefixed_query[4]).'</b>.</br />';
				}
			}
		}
	}

	// TEMPLATES
	$tplfile_handler =& xoops_gethandler( 'tplfile' ) ;
	$trust_tpl_path = dirname(__FILE__).'/templates';
	$tpl_path = XOOPS_ROOT_PATH.'/modules/'.$mydirname.'/templates';

	if( $handler = @opendir( $trust_tpl_path . '/' ) ) {
		while ( ( $file = readdir( $handler ) ) !== false ) {
			if ( substr( $file , 0 , 1 ) == '.' ) continue ;
			$file_path = $tpl_path . '/' . $file ;

			if (!file_exists($file_path)) {
				$file_path = $trust_tpl_path . '/' . $file ;
			}

			if ( is_file( $file_path ) ) {
				$mtime = intval( @filemtime( $file_path ) ) ;
				$tplfile =& $tplfile_handler->create() ;
				$tplfile->setVar( 'tpl_source' , file_get_contents( $file_path ) , true ) ;
				$tplfile->setVar( 'tpl_refid' , $mid ) ;
				$tplfile->setVar( 'tpl_tplset' , 'default' ) ;
				$tplfile->setVar( 'tpl_file' , $mydirname . '_' . $file ) ;
				$tplfile->setVar( 'tpl_desc' , '' , true ) ;
				$tplfile->setVar( 'tpl_module' , $mydirname ) ;
				$tplfile->setVar( 'tpl_lastmodified' , $mtime ) ;
				$tplfile->setVar( 'tpl_lastimported' , 0 ) ;
				$tplfile->setVar( 'tpl_type' , 'module' ) ;
				if ( ! $tplfile_handler->insert( $tplfile ) ) {
					$ret[] = '<span style="color:#ff0000;">ERROR: Could not insert template <b>'.htmlspecialchars($mydirname.'_'.$file).'</b> to the database.</span><br />';
				} else {
					$tplid = $tplfile->getVar( 'tpl_id' ) ;
					$ret[] = 'Template <b>'.htmlspecialchars($mydirname.'_'.$file).'</b> added to the database. (ID: <b>'.$tplid.'</b>)<br />';
					if ( ! xdbaseTemplateTouch( $tplid ) ) {
						$ret[] = '<span style="color:#ff0000;">ERROR: Failed compiling template <b>'.htmlspecialchars($mydirname.'_'.$file).'</b>.</span><br />';
					} else {
						$ret[] = 'Template <b>'.htmlspecialchars($mydirname.'_'.$file).'</b> compiled.</span><br />';
					}
				}
			}
		}
		closedir( $handler ) ;
	}

	include_once XOOPS_ROOT_PATH.'/class/xoopsblock.php' ;
	include_once XOOPS_ROOT_PATH.'/class/template.php' ;
	xoops_template_clear_module_cache( $mid ) ;


	// BLOCKS
	$tpl_path = XOOPS_ROOT_PATH.'/modules/'.$mydirname.'/templates/blocks';
	$trust_tpl_path = dirname(__FILE__).'/templates/blocks';
	if( $handler = @opendir( $trust_tpl_path . '/' ) ) {
		while( ( $file = readdir( $handler ) ) !== false ) {
			if( substr( $file , 0 , 1 ) == '.' ) continue ;
			$file_path = $tpl_path . '/' . $mydirname . '_' . $file;
			if (!file_exists($file_path)) {
				$file_path = $trust_tpl_path . '/' . $file ;
			}
			if( is_file( $file_path ) && substr( $file , -5 ) == '.html' ) {
				$mtime = intval( @filemtime( $file_path ) ) ;
				$tpl_file = $mydirname . '_' . $file;
				$sql = "SELECT tpl_id FROM ".$db->prefix('tplfile')." WHERE tpl_module='$mydirname' AND tpl_file='".mysql_escape_string($tpl_file)."'";
				list($tpl_id) = $db->fetchRow($db->query($sql));
				$tpl_source = file_get_contents( $file_path );
				if (!empty($tpl_id) && isset($tpl_source) && $tpl_source != '') {
					$sql = sprintf("INSERT INTO %s (tpl_id, tpl_source) VALUES (%u, %s)", $db->prefix('tplsource'), $tpl_id, $db->quoteString($tpl_source));
					if( !$result = $db->query($sql) ) {
						$ret[] = '<span style="color:#ff0000;">ERROR: Could not insert template <b>'.htmlspecialchars($mydirname.'_'.$file).'</b> to the database.</span><br />';
					} else {
						$ret[] = 'Template <b>'.htmlspecialchars($mydirname.'_'.$file).'</b> added to the database. (ID: <b>'.$tpl_id.'</b>)<br />';
						// generate compiled file
						include_once XOOPS_ROOT_PATH.'/class/template.php';
						if( ! xdbaseTemplateTouch( $tpl_id ) ) {
							$ret[] = '<span style="color:#ff0000;">ERROR: Failed compiling template <b>'.htmlspecialchars($mydirname.'_'.$file).'</b>.</span><br />';
						} else {
							$ret[] = 'Template <b>'.htmlspecialchars($mydirname.'_'.$file).'</b> compiled.</span><br />';
						}
					}
				}
			}
		}
		closedir( $handler ) ;
	}

	addDataConfigTable($mydirname, $ret);

	return true ;
}

function xdbase_message_append_oninstall( &$module_obj , &$log )
{
	if ( is_array( @$GLOBALS['ret'] ) ) {
		foreach ( $GLOBALS['ret'] as $message ) {
			$log->add( strip_tags( $message ) ) ;
		}
	}

	// use mLog->addWarning() or mLog->addError() if necessary
}
///////////////////////////////////////////////////////////////////////////////////////////////////////
function addDataConfigTable($mydirname, $ret)
{
	require_once XOOPS_TRUST_PATH.'/modules/'.XDBASE_TRUST_DIRNAME.'/language/'.$GLOBALS['xoopsConfig']['language'].'/main.php';
	$db =& $GLOBALS['xoopsDB'];

	$valueArray = array();
	array_push($valueArray, "'1','did','"._MD_XDBASE_LANG_ABSTRACT_DID."','2','0','1','1','0','0'");
	array_push($valueArray, "'2','cid','"._MD_XDBASE_LANG_ABSTRACT_CID."','0','0','0','0','0','0'");
	array_push($valueArray, "'3','title','"._MD_XDBASE_LANG_ABSTRACT_TITLE."','2','1','1','1','0',''");
	array_push($valueArray, "'4','tag','"._MD_XDBASE_LANG_ABSTRACT_TAG."','0','0','0','0','0',''");
	array_push($valueArray, "'5','pid','"._MD_XDBASE_LANG_ABSTRACT_PID."','0','0','0','0','0','0'");
	array_push($valueArray, "'6','uid','"._MD_XDBASE_LANG_ABSTRACT_UID."','0','1','1','1','0','0'");
	array_push($valueArray, "'7','name','"._MD_XDBASE_LANG_ABSTRACT_NAME."','0','0','0','0','0',''");
	array_push($valueArray, "'8','poster_ip','"._MD_XDBASE_LANG_ABSTRACT_POSTER_IP."','0','0','0','0','0',''");
	array_push($valueArray, "'9','created_date','"._MD_XDBASE_LANG_ABSTRACT_CREATED_DATE."','0','0','0','0','0','0'");
	array_push($valueArray, "'10','updated_date','"._MD_XDBASE_LANG_ABSTRACT_UPDATED_DATE."','0','0','1','1','0','0'");
	array_push($valueArray, "'11','published_date','"._MD_XDBASE_LANG_ABSTRACT_PUBLISHED_DATE."','0','0','0','0','0','0'");
	array_push($valueArray, "'12','expired_date','"._MD_XDBASE_LANG_ABSTRACT_EXPIRED_DATE."','0','0','0','0','0','0'");
	array_push($valueArray, "'13','s_date','"._MD_XDBASE_LANG_ABSTRACT_S_DATE."','0','0','0','0','0','0'");
	array_push($valueArray, "'14','e_date','"._MD_XDBASE_LANG_ABSTRACT_E_DATE."','0','0','0','0','0','0'");
	array_push($valueArray, "'15','password','"._MD_XDBASE_LANG_ABSTRACT_PASSWORD."','0','0','0','0','0',''");
	array_push($valueArray, "'16','url','"._MD_XDBASE_LANG_ABSTRACT_URL."','0','0','0','0','1',''");
	array_push($valueArray, "'17','email','"._MD_XDBASE_LANG_ABSTRACT_EMAIL."','0','0','0','0','1',''");
	array_push($valueArray, "'18','zip','"._MD_XDBASE_LANG_ABSTRACT_ZIP."','0','0','0','0','1',''");
	array_push($valueArray, "'19','state','"._MD_XDBASE_LANG_ABSTRACT_STATE."','0','0','0','0','1',''");
	array_push($valueArray, "'20','city','"._MD_XDBASE_LANG_ABSTRACT_CITY."','0','0','0','0','1',''");
	array_push($valueArray, "'21','street','"._MD_XDBASE_LANG_ABSTRACT_STREET."','0','0','0','0','1',''");
	array_push($valueArray, "'22','phone','"._MD_XDBASE_LANG_ABSTRACT_PHONE."','0','0','0','0','1',''");
	array_push($valueArray, "'23','mobile_phone','"._MD_XDBASE_LANG_ABSTRACT_MOBILE_PHONE."','0','0','0','0','1',''");
	array_push($valueArray, "'24','fax','"._MD_XDBASE_LANG_ABSTRACT_FAX."','0','0','0','0','1',''");
	array_push($valueArray, "'25','show_map','"._MD_XDBASE_LANG_ABSTRACT_SHOW_MAP."','0','0','0','0','0','0'");
	array_push($valueArray, "'26','latitude','"._MD_XDBASE_LANG_ABSTRACT_LATITUDE."','0','0','0','0','1','0'");
	array_push($valueArray, "'27','longitude','"._MD_XDBASE_LANG_ABSTRACT_LONGITUDE."','0','0','0','0','1','0'");
	array_push($valueArray, "'28','zoom','"._MD_XDBASE_LANG_ABSTRACT_ZOOM."','0','0','0','0','1','0'");
	array_push($valueArray, "'29','img01','"._MD_XDBASE_LANG_ABSTRACT_IMG01."','0','0','0','0','0',''");
	array_push($valueArray, "'30','img01_height','"._MD_XDBASE_LANG_ABSTRACT_IMG01_HEIGHT."','0','0','0','0','0',''");
	array_push($valueArray, "'31','img01_width','"._MD_XDBASE_LANG_ABSTRACT_IMG01_WIDTH."','0','0','0','0','0',''");
	array_push($valueArray, "'32','img02','"._MD_XDBASE_LANG_ABSTRACT_IMG02."','0','0','0','0','0',''");
	array_push($valueArray, "'33','img02_height','"._MD_XDBASE_LANG_ABSTRACT_IMG02_HEIGHT."','0','0','0','0','0',''");
	array_push($valueArray, "'34','img02_width','"._MD_XDBASE_LANG_ABSTRACT_IMG02_WIDTH."','0','0','0','0','0',''");
	array_push($valueArray, "'35','file01','"._MD_XDBASE_LANG_ABSTRACT_FILE01."','0','0','0','0','0',''");
	array_push($valueArray, "'36','file01name','"._MD_XDBASE_LANG_ABSTRACT_FILE01NAME."','0','0','0','0','0',''");
	array_push($valueArray, "'37','file01ext','"._MD_XDBASE_LANG_ABSTRACT_FILE01EXT."','0','0','0','0','0',''");
	array_push($valueArray, "'38','file01size','"._MD_XDBASE_LANG_ABSTRACT_FILE01SIZE."','0','0','0','0','0','0.00'");
	array_push($valueArray, "'39','body','"._MD_XDBASE_LANG_ABSTRACT_BODY."','1','1','0','1','3',''");
	array_push($valueArray, "'40','int01','"._MD_XDBASE_LANG_ABSTRACT_INT01."','0','0','0','0','1','0'");
	array_push($valueArray, "'41','int02','"._MD_XDBASE_LANG_ABSTRACT_INT02."','0','0','0','0','1','0'");
	array_push($valueArray, "'42','int03','"._MD_XDBASE_LANG_ABSTRACT_INT03."','0','0','0','0','1','0'");
	array_push($valueArray, "'43','int04','"._MD_XDBASE_LANG_ABSTRACT_INT04."','0','0','0','0','1','0'");
	array_push($valueArray, "'44','int05','"._MD_XDBASE_LANG_ABSTRACT_INT05."','0','0','0','0','1','0'");
	array_push($valueArray, "'45','int06','"._MD_XDBASE_LANG_ABSTRACT_INT06."','0','0','0','0','1','0'");
	array_push($valueArray, "'46','int07','"._MD_XDBASE_LANG_ABSTRACT_INT07."','0','0','0','0','1','0'");
	array_push($valueArray, "'47','int08','"._MD_XDBASE_LANG_ABSTRACT_INT08."','0','0','0','0','1','0'");
	array_push($valueArray, "'48','int09','"._MD_XDBASE_LANG_ABSTRACT_INT09."','0','0','0','0','1','0'");
	array_push($valueArray, "'49','int10','"._MD_XDBASE_LANG_ABSTRACT_INT10."','0','0','0','0','1','0'");
	array_push($valueArray, "'50','float01','"._MD_XDBASE_LANG_ABSTRACT_FLOAT01."','0','0','0','0','1','0.0000'");
	array_push($valueArray, "'51','float02','"._MD_XDBASE_LANG_ABSTRACT_FLOAT02."','0','0','0','0','1','0.0000'");
	array_push($valueArray, "'52','varchar01','"._MD_XDBASE_LANG_ABSTRACT_VARCHAR01."','0','0','0','0','1',''");
	array_push($valueArray, "'53','varchar02','"._MD_XDBASE_LANG_ABSTRACT_VARCHAR02."','0','0','0','0','1',''");
	array_push($valueArray, "'54','varchar03','"._MD_XDBASE_LANG_ABSTRACT_VARCHAR03."','0','0','0','0','1',''");
	array_push($valueArray, "'55','varchar04','"._MD_XDBASE_LANG_ABSTRACT_VARCHAR04."','0','0','0','0','1',''");
	array_push($valueArray, "'56','varchar05','"._MD_XDBASE_LANG_ABSTRACT_VARCHAR05."','0','0','0','0','1',''");
	array_push($valueArray, "'57','varchar06','"._MD_XDBASE_LANG_ABSTRACT_VARCHAR06."','0','0','0','0','1',''");
	array_push($valueArray, "'58','varchar07','"._MD_XDBASE_LANG_ABSTRACT_VARCHAR07."','0','0','0','0','1',''");
	array_push($valueArray, "'59','varchar08','"._MD_XDBASE_LANG_ABSTRACT_VARCHAR08."','0','0','0','0','1',''");
	array_push($valueArray, "'60','varchar09','"._MD_XDBASE_LANG_ABSTRACT_VARCHAR09."','0','0','0','0','1',''");
	array_push($valueArray, "'61','varchar10','"._MD_XDBASE_LANG_ABSTRACT_VARCHAR10."','0','0','0','0','1',''");
	array_push($valueArray, "'62','text01','"._MD_XDBASE_LANG_ABSTRACT_TEXT01."','0','0','0','0','3',''");
	array_push($valueArray, "'63','text02','"._MD_XDBASE_LANG_ABSTRACT_TEXT02."','0','0','0','0','2',''");
	array_push($valueArray, "'64','reservation','"._MD_XDBASE_LANG_ABSTRACT_RESERVATION."','0','0','0','0','5','0'");
	array_push($valueArray, "'65','option_value','"._MD_XDBASE_LANG_ABSTRACT_OPTION_VALUE."','0','0','0','0','0',''");
	array_push($valueArray, "'66','weight','"._MD_XDBASE_LANG_ABSTRACT_WEIGHT."','0','0','0','0','1','0'");
	array_push($valueArray, "'67','status','"._MD_XDBASE_LANG_ABSTRACT_STATUS."','0','0','0','0','5','1'");
	array_push($valueArray, "'68','access','"._MD_XDBASE_LANG_ABSTRACT_ACCESS."','0','0','0','0','5','0'");
	array_push($valueArray, "'69','groups','"._MD_XDBASE_LANG_ABSTRACT_GROUPS."','0','0','0','0','6','0'");
	array_push($valueArray, "'70','hits','"._MD_XDBASE_LANG_ABSTRACT_HITS."','0','0','0','0','1','0'");
	array_push($valueArray, "'71','comments','"._MD_XDBASE_LANG_ABSTRACT_COMMENTS."','0','0','0','0','1','0'");
	array_push($valueArray, "'72','rating','"._MD_XDBASE_LANG_ABSTRACT_RATING."','0','0','0','0','1','0.0000'");
	array_push($valueArray, "'73','votes','"._MD_XDBASE_LANG_ABSTRACT_VOTES."','0','0','0','0','1','0'");
	array_push($valueArray, "'74','downloads','"._MD_XDBASE_LANG_ABSTRACT_DOWNLOADS."','0','0','0','0','1','0'");
	array_push($valueArray, "'75','trackbacks','"._MD_XDBASE_LANG_ABSTRACT_TRACKBACKS."','0','0','0','0','1','0'");
	array_push($valueArray, "'76','pipe_id','"._MD_XDBASE_LANG_ABSTRACT_PIPE_ID."','0','0','0','0','6','0'");
	array_push($valueArray, "'77','dohtml','"._MD_XDBASE_LANG_ABSTRACT_DOHTML."','0','0','0','0','5','0'");
	array_push($valueArray, "'78','doxcode','"._MD_XDBASE_LANG_ABSTRACT_DOXCODE."','0','0','0','0','5','1'");
	array_push($valueArray, "'79','dosmiley','"._MD_XDBASE_LANG_ABSTRACT_DOSMILEY."','0','0','0','0','5','1'");
	array_push($valueArray, "'80','doimage','"._MD_XDBASE_LANG_ABSTRACT_DOIMAGE."','0','0','0','0','5','1'");
	array_push($valueArray, "'81','dobr','"._MD_XDBASE_LANG_ABSTRACT_DOBR."','0','0','0','0','5','1'");

	foreach ($valueArray as $value)
	{
		$sql = 'INSERT INTO '.$db->prefix($mydirname.'_data_config').' (configid,col,name,active,search,show_list,show_article,input_type,default_value) values ('.$value.');';
		if (!$db->query($sql))
		{
			$ret[] = 'Could not insert data_config table:'.$db->error();
			$ret[] = $sql;
		}
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////


}



?>
